#CONTROLCODES 1
#INCLUDE "/BASIC/INCLUDES/STANDARD.DEF"

MAIN:

BIT16.ON = %00100000
STEREO.ON = %00010000
DefaultVolume = 13

IsPaused = 0
IsFinished = 0
PlayFinished = 0

  BMX.BANKLOADER=$A019
  StartPCM.Play = $A02D
  AUDIO.DELAY = 360

GOSUB SAVE.SCREEN.MODE
GOSUB SaveCursor.AndColor
REM ALLOCATE SPACE FOR THE BMX FILE HEADER
BMX.HDR$=RPT$(32,32)
BMX.HDRSIZE=32
F$="BMXA000.BIN":GOSUB FILEEXISTS
BLOADER=FE%
F$="AUTOBOOT.BMX":GOSUB FILEEXISTS
BSPLASH=FE%
IS.IMAGE = (BSPLASH AND BLOADER)
IF NOT IS.IMAGE THEN SKIPGRAPHIC
 BLOAD "BMXA000.BIN",8,2,$A000
 SCREEN $80
 BMX$=F$
 GOSUB HIDEGRAPHICS
 RECT 0,0,319,239,0
 WASERROR=0:CLS
 BMXFILE$=F$
 GOSUB LOADBMX
 GOSUB SHOWGRAPHICS
 IF WASERROR THEN GOSUB RESTOREMODE
 X=0
 F$="IMAGEDELAY":GOSUB FILEEXISTS
 IF FE% THEN OPEN 4,8,4,"IMAGEDELAY,S,R":INPUT# 4, X$:CLOSE 4:X=VAL(X$)
 IF X>0 THEN AUDIODELAY=X*60

SKIPGRAPHIC:
 F$="WAVMODULE.BIN":GOSUB FILEEXISTS
 BLOADER=FE%
 F$="AUTOBOOT.WAV":GOSUB FILEEXISTS
 BSPLASH=FE%
 IF NOT (BSPLASH AND BLOADER) THEN TI=0:GOTO SKIPPLAY
 BLOAD "WAVMODULE.BIN",8,3,$A000
 F$="AUTOBOOT.WAV"

 GOSUB LOADWAVE
 IF NOT IsSupported THEN PRINT:PRINT " {LIGHT RED}{BELL}WAVE FILE ERROR {RED}!{WHT}":PRINT:SLEEP 90:CLOSE 6:GOTO SKIPPLAY
 TI=0
 GOSUB PLAY.Wave.File
SKIPPLAY:
 IF NOT IS.IMAGE THEN SKIPIMAGEDELAY
 FOR I=0 TO 1 STEP 0
     GET X$
     IF X$="{ESC}" THEN I=1
     IF TI>AUDIODELAY THEN I=1
 NEXT I

SKIPIMAGEDELAY:
  GOSUB RESTOREMODE
  F$="AUTOBOOT.ORG":GOSUB FILEEXISTS
  IF FE% THEN LOAD F$
  F$="AUTOBOOT.OLD":GOSUB FILEEXISTS
  IF FE% THEN LOAD F$
  CLS
  BANNER
  PRINT
  NEW

LOADWAVE:
   GOSUB LoadWAVEHeader
   GOSUB ParseRIFFHeader
   RETURN

PLAY.Wave.File:
   UserEnded = 0
   PAUSED = 0
   FillLoopCount = 6
   IF BytesPerSecond > 79999 THEN FillLoopCount = FillLoopCount+1
   IF BytesPerSecond > 100000 THEN FillLoopCount = FillLoopCount+1
   POKE A.REG, FillLoopCount
   POKE X.REG, 6
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   POKE R1L, 0
   BANK 3
   SYS StartPCM.Play
getPKey:
   rKey = PEEK(R2L)
   IF rKey = 27 THEN UserEnded = -1
   IF rKey = 0 OR rKey = 27 THEN CLOSE 6:RETURN
   IF rKey = 32 THEN GOSUB Wait32
   GOTO getPKey

Wait32:
  GOSUB SaveCursor.AndColor
  LOCATE 25, 4
  COLOR 1,11:PRINT "{LIGHT GREEN}*{YEL} PAUSED {LIGHT GREEN}*"
  FOR I = 0 TO 1 STEP 0
    GET K$
    K=ASC(K$)
    IF K=32 THEN GOSUB MSGCLR:I=1
    IF K=27 THEN POKE R2L,27:I=1
  NEXT I
  RETURN

MSGCLR:
  POKE R2L,0
  COLOR 1,0
  LOCATE 25,4
  PRINT RPT$(32,11);
  GOSUB RestoreCursor.AndColor
  BANK 3
  SYS ContinuePCM.Play
  RETURN

ParseRIFFHeader:
  IsWave = (LEFT$(RIFFHDR$,4) = "RIFF") AND (MID$(RIFFHDR$,9,4)="WAVE")
  PCMBits = ASC(MID$(RIFFHDR$,35,1))
  TMP1 = ASC(MID$(RIFFHDR$,21,1))
  TMP2 = ASC(MID$(RIFFHDR$,22,1))
  NumChannels = ASC(MID$(RIFFHDR$,23,1))
  TMP4 = (TMP1) + (256*TMP2)
  IsPCM = (TMP4=1)
  TMP1 = ASC(MID$(RIFFHDR$,25,1))
  TMP2 = ASC(MID$(RIFFHDR$,26,1)) * 256
  TMP3 = ASC(MID$(RIFFHDR$,27,1)) * 65536
  SampleRate = TMP1+TMP2+TMP3
  VERA.RATE = FN ROUND((SampleRate / 48828.15) * 128)
  IsStereo = (NumChannels=2)
  IsSupported = (IsWave AND (PCMBits=16)) AND IsPCM AND ((NumChannels > 0) AND (NumChannels < 3))
  VERA.CFG=0
  IF NOT IsSupported THEN RETURN
  VERA.CFG = (VERA.CFG OR BIT16.ON)
  IF IsStereo THEN VERA.CFG = (VERA.CFG OR STEREO.ON)
  VERA.CFG = VERA.CFG OR DefaultVolume
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)*2
  IF IsStereo THEN BytesPerSecond = BytesPerSecond*2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

LoadWAVEHeader:
   RIFFHDR$ = RPT$(44,44)
   OPEN 6,8,6,F$+",S,R"
     POKE X.REG, 6
     SYS CHKIN
     POKE A.REG, 44
## GET A POINTER TO THE WAVEHDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(RIFFHDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     RETURN

LOADBMX:
     OPEN 4,8,4,BMXFILE$+",S,R"
     POKE X.REG, 4
     SYS CHKIN
     POKE A.REG, 32
## GET A POINTER TO THE BMX.HDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(BMX.HDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     WASERROR = 0
     DOSHOW = 0
     GOSUB PARSEHEADER
     IF BMX.ID$<>"BMX" THEN ERRMSG$= "{RED}"+F$+"{WHT} IS NOT A BMX FILE":GOTO ERR.EXIT1
     IF BMX.BITS<>8 THEN ERRMSG$= "{RED}"+STR$(BMX.BITS)+"{WHT} BITS NOT SUPPORTED":GOTO ERR.EXIT1
     IF BMX.VER<>1 THEN ERRMSG$= "{RED}"+F$+"{WHT} IS VERSION:{RED}"+STR$(BMX.VER)+"{WHT} NOT SUPPORTED!":GOTO ERR.EXIT1
     IF BMX.WIDTH > 320 THEN ERRMSG$= "{RED}"+STR$(BMX.WIDTH)+"{WHT} WIDTH NOT CURRENTLY SUPPORTED":GOTO ERR.EXIT1
     POKE R0L, FN Lo.Byte(BMX.WIDTH)
     POKE R0H, FN Hi.Byte(BMX.WIDTH)
     POKE R1L, FN Lo.Byte(BMX.HEIGHT)
     POKE R1H, FN Hi.Byte(BMX.HEIGHT)
     POKE R2L, BMX.PALUSED
     POKE R2H, BMX.FIRSTPAL
     BANK 2
     SYS BMX.BANKLOADER
RETURN

ERR.EXIT1:
 CLOSE 4:SYS CLRCHN
ERR.EXIT:
 PRINT:PRINT " ";ERRMSG$:WASERROR=-1:RETURN

PARSEHEADER:
    BMX.ID$=LEFT$(BMX.HDR$,3)
    BMX.VER=ASC(MID$(BMX.HDR$,4,1))
    BMX.BITS = ASC(MID$(BMX.HDR$,5,1))
    BMX.VERA.REG=ASC(MID$(BMX.HDR$,6,1))
    BMX.WIDTH = ASC(MID$(BMX.HDR$,7,1)) + (ASC(MID$(BMX.HDR$,8,1))*256)
    BMX.HEIGHT = ASC(MID$(BMX.HDR$,9,1)) + (ASC(MID$(BMX.HDR$,10,1))*256)
    BMX.PALUSED = ASC(MID$(BMX.HDR$,11,1))
    BMX.FIRSTPAL = ASC(MID$(BMX.HDR$,12,1))
    BMX.FILE.OFFSET = ASC(MID$(BMX.HDR$,13,1))+(ASC(MID$(BMX.HDR$,14,1))*256)
    BMX.COMPRESS= ASC(MID$(BMX.HDR$,15,1))
   RETURN

RESTOREMODE:
 IF IS.IMAGE THEN GOSUB PAL2BLACK:RECT 0,0,XLIMIT,YLIMIT,0
 GOSUB SETDEFPAL
 GOSUB RESTORE.SCREEN.MODE
 GOTO RestoreCursor.AndColor



## BELOW IS CODE FOR VARIOUS FADE TRANSITIONS

REM SET THE PALLETTE TO ALL BLACK
PAL2BLACK:
    FOR A=$FA00 TO $FBFF:VPOKE 1,A,0:NEXT A:RETURN

SETDEFPAL:
      F$="DPAL.BIN":GOSUB FILEEXISTS
      IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
      POKE $9F20, 0
      POKE $9F21, $FA
      POKE $9F22, %00010001
      RESTORE PALDATA
REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
REM AND POKE THE VERA DEFAULT PALLETTE
      FOR PE = 1 TO 256:READ R:READ GB:POKE $9F23,GB:POKE $9F23,R:NEXT
      RETURN

REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
PALDATA:
      DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
      DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
      DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
      DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
      DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
      DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
      DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
      DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
      DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
      DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
      DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
      DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
      DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
      DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
      DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
      DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
      DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
      DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
      DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
      DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
      DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
      DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
      DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
      DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
      DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
      DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
      DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
      DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
      DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
      DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
      DATA $0F,$0B


#INCLUDE "/BASIC/INCLUDES/STANDARD.BI"

